<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><link rel="canonical" href="https://gitlab.eclipse.org/eclipse/xfsc/xfsc-spec-2/tsae1/tsae1/" />
      <link rel="shortcut icon" href="../../img/favicon.ico" />
    <title>Trust Services API Extension - XFSC-spec-2</title>
    <link rel="stylesheet" href="../../css/theme.css" />
    <link rel="stylesheet" href="../../css/theme_extra.css" />
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.8.0/styles/github.min.css" />
    
      <script>
        // Current page data
        var mkdocs_page_name = "Trust Services API Extension";
        var mkdocs_page_input_path = "tsae1\\tsae1.md";
        var mkdocs_page_url = "/eclipse/xfsc/xfsc-spec-2/tsae1/tsae1/";
      </script>
    
    <!--[if lt IE 9]>
      <script src="../../js/html5shiv.min.js"></script>
    <![endif]-->
      <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.8.0/highlight.min.js"></script>
      <script>hljs.highlightAll();</script> 
</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side stickynav">
    <div class="wy-side-scroll">
      <div class="wy-side-nav-search">
          <a href="../.." class="icon icon-home"> XFSC-spec-2
        </a><div role="search">
  <form id ="rtd-search-form" class="wy-form" action="../../search.html" method="get">
      <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" title="Type search term here" />
  </form>
</div>
      </div>

      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../..">Index</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../notare/notare/">Notarization API Extension</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../train/train/">Trust Management Infrastructure</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../ocme1/ocme1/">Organization Credential Manager Extension</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../ocmwstack/ocmwstack/">Organization Credential Manager W-STACK</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../pcmcloud/pcmcloud/">Cloud Personal Credential Manager</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../pcme1/pcme1/">Personal Credential Manager Extension 1</a>
                </li>
              </ul>
              <ul class="current">
                <li class="toctree-l1 current"><a class="reference internal current" href="./">Trust Services API Extension</a>
    <ul class="current">
    <li class="toctree-l2"><a class="reference internal" href="#1-introduction">1  Introduction</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#11-document-purpose">1.1  Document Purpose</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#12-product-scope">1.2  Product Scope</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#13-definitions-acronyms-and-abbreviations">1.3  Definitions, Acronyms and Abbreviations</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#14-references">1.4  References</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#15-document-overview">1.5  Document Overview</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#2-product-overview">2  Product Overview</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#21-product-perspective">2.1  Product Perspective</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#22-product-functions">2.2  Product Functions</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#23-product-constraints">2.3  Product Constraints</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#24-user-classes-and-characteristics">2.4  User Classes and Characteristics</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#25-operating-environment">2.5  Operating Environment</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#26-user-documentation">2.6  User Documentation</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#27-assumptions-and-dependencies">2.7  Assumptions and Dependencies</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#28-apportioning-of-requirements">2.8  Apportioning of Requirements</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#3-requirements">3  Requirements</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#31-external-interfaces">3.1  External Interfaces</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#311-user-interfaces">3.1.1  User Interfaces</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#312-hardware-interfaces">3.1.2  Hardware Interfaces</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#313-software-interfaces">3.1.3  Software Interfaces</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#314-communications-interfaces">3.1.4  Communications Interfaces</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#32-functional">3.2  Functional</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#321-policy-management-module">3.2.1  Policy Management Module</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#322-policy-decision-engine">3.2.2  Policy Decision Engine</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#323-task-controller">3.2.3  Task Controller</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#324-json-ld-signatures-and-validations">3.2.4  JSON-LD signatures and validations</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#325-distributable-cache">3.2.5  Distributable Cache</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#326-eidas">3.2.6  eIDAS</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#327-general">3.2.7  General</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#33-other-nonfunctional-requirements">3.3  Other Nonfunctional Requirements</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#331-http-requirements">3.3.1  HTTP Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#332-logging-requirements">3.3.2  Logging Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#333-performance-requirements">3.3.3  Performance Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#334-safety-requirements">3.3.4  Safety Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#335-security-requirements">3.3.5  Security Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#336-software-quality-attributes">3.3.6  Software Quality Attributes</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#337-business-rules">3.3.7  Business Rules</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#34-compliance">3.4  Compliance</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#35-design-and-implementation">3.5  Design and Implementation</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#351-installation">3.5.1  Installation</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#352-distribution">3.5.2  Distribution</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#353-service-meshing">3.5.3  Service Meshing</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#354-standard-technology">3.5.4  Standard Technology</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#355-metrics">3.5.5  Metrics</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#356-configurability">3.5.6  Configurability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#357-maintainability">3.5.7  Maintainability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#358-reusability">3.5.8  Reusability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#359-runtime-stability">3.5.9  Runtime Stability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#3510-high-availability-concepts">3.5.10 High Availability Concepts</a>
    </li>
        </ul>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#4-system-features">4  System Features</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#41-policy-management">4.1  Policy Management</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#411-description">4.1.1  Description</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#412-functional-requirements">4.1.2  Functional Requirements</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#42-policy-evaluation">4.2  Policy Evaluation</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#421-description">4.2.1  Description</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#422-functional-requirements">4.2.2  Functional Requirements</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#43-task-controller">4.3  Task Controller</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#431-description">4.3.1  Description</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#432-functional-requirements">4.3.2  Functional Requirements</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#44-json-ld-signing-and-verification">4.4  JSON-LD Signing and verification</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#441-description">4.4.1  Description</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#442-functional-requirements">4.4.2  Functional Requirements</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#45-trusted-caching">4.5  Trusted Caching</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#451-description">4.5.1  Description</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#452-functional-requirements">4.5.2  Functional Requirements</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#46-eidas-compliant-signatures">4.6  eIDAS Compliant Signatures</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#461-description">4.6.1  Description</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#462-functional-requirements">4.6.2  Functional Requirements</a>
    </li>
        </ul>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#5-verification">5  Verification</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#51-core-verification-requirements">5.1  Core Verification Requirements</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#52-acceptance-criteria">5.2  Acceptance Criteria</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#521-policy-management-module">5.2.1  Policy Management Module</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#522-policy-decision-engine">5.2.2  Policy Decision Engine</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#523-task-controller">5.2.3  Task Controller</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#524-json-ld-signatures-and-validations">5.2.4  JSON-LD signatures and validations</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#525-distributable-cache">5.2.5  Distributable Cache</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#526-eidas">5.2.6  eIDAS</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#53-support-for-kubernetes">5.3  Support for Kubernetes</a>
    </li>
        </ul>
    </li>
    </ul>
                </li>
              </ul>
      </div>
    </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
      <nav class="wy-nav-top" role="navigation" aria-label="Mobile navigation menu">
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../..">XFSC-spec-2</a>
        
      </nav>
      <div class="wy-nav-content">
        <div class="rst-content"><div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../.." class="icon icon-home" aria-label="Docs"></a></li>
      <li class="breadcrumb-item active">Trust Services API Extension</li>
    <li class="wy-breadcrumbs-aside">
    </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
            <div class="section" itemprop="articleBody">
              
                <h2 id="software-requirements-specification-for-gaia-x-federation-services-trust-services-api-extension-1-idmtsae1">Software Requirements Specification for Gaia-X Federation Services Trust Services API Extension 1 IDM.TSA.E1</h2>
<p>Published by</p>
<p>eco -- Association of the Internet Industry (eco -- Verband der Internetwirtschaft e.V.) Lichtstrasse 43h 50825 Cologne, Germany</p>
<p>Copyright </p>
<p>© 2023 eco -- Association of the Internet Industry
This work is licensed under the Creative Commons attribution 4.0nInternational License. To view a copy of this license, visit <a href="http://creativecommons.org/licenses/by/4.0/">http://creativecommons.org/licenses/by/4.0/</a> or send a letter to Creative Commons, PO Box 1866, Mountain View, CA 94042, USA</p>
<p><img alt="" src="../media/image1.png" /></p>
<h4 id="1-introduction">1  <a href="#introduction">Introduction </a></h4>
<blockquote>
<h5 id="11-document-purpose">1.1  <a href="#document-purpose">Document Purpose </a></h5>
<h5 id="12-product-scope">1.2  <a href="#product-scope">Product Scope </a></h5>
<h5 id="13-definitions-acronyms-and-abbreviations">1.3  <a href="#definitions-acronyms-and-abbreviations">Definitions, Acronyms and Abbreviations</a></h5>
<h5 id="14-references">1.4  <a href="#references">References </a></h5>
<h5 id="15-document-overview">1.5  <a href="#document-overview">Document Overview </a></h5>
</blockquote>
<h4 id="2-product-overview">2  <a href="#product-overview">Product Overview </a></h4>
<blockquote>
<h5 id="21-product-perspective">2.1  <a href="#product-perspective">Product Perspective </a></h5>
<h5 id="22-product-functions">2.2  <a href="#product-functions">Product Functions </a></h5>
<h5 id="23-product-constraints">2.3  <a href="#product-constraints">Product Constraints </a></h5>
<h5 id="24-user-classes-and-characteristics">2.4  <a href="#user-classes-and-characteristics">User Classes and Characteristics</a></h5>
<h5 id="25-operating-environment">2.5  <a href="#operating-environment">Operating Environment </a></h5>
<h5 id="26-user-documentation">2.6  <a href="#user-documentation">User Documentation </a></h5>
<h5 id="27-assumptions-and-dependencies">2.7  <a href="#assumptions-and-dependencies">Assumptions and Dependencies </a></h5>
<h5 id="28-apportioning-of-requirements">2.8  <a href="#apportioning-of-requirements">Apportioning of Requirements</a></h5>
</blockquote>
<h4 id="3-requirements">3  <a href="#requirements">Requirements </a></h4>
<blockquote>
<h5 id="31-external-interfaces">3.1  <a href="#external-interfaces">External Interfaces </a></h5>
<blockquote>
<h6 id="311-user-interfaces">3.1.1  <a href="#user-interfaces">User Interfaces </a></h6>
<h6 id="312-hardware-interfaces">3.1.2  <a href="#hardware-interfaces">Hardware Interfaces </a></h6>
<h6 id="313-software-interfaces">3.1.3  <a href="#software-interfaces">Software Interfaces </a></h6>
<h6 id="314-communications-interfaces">3.1.4  <a href="#communications-interfaces">Communications Interfaces </a></h6>
</blockquote>
<h5 id="32-functional">3.2  <a href="#functional">Functional </a></h5>
<blockquote>
<h6 id="321-policy-management-module">3.2.1  <a href="#policy-management-module">Policy Management Module </a></h6>
<h6 id="322-policy-decision-engine">3.2.2  <a href="#policy-decision-engine">Policy Decision Engine </a></h6>
<h6 id="323-task-controller">3.2.3  <a href="#task-controller">Task Controller </a></h6>
<h6 id="324-json-ld-signatures-and-validations">3.2.4  <a href="#json-ld-signatures-and-validations">JSON-LD signatures and validations</a></h6>
<h6 id="325-distributable-cache">3.2.5  <a href="#distributable-cache">Distributable Cache </a></h6>
<h6 id="326-eidas">3.2.6  <a href="#eidas">eIDAS </a></h6>
<h6 id="327-general">3.2.7  <a href="#general">General </a></h6>
</blockquote>
<h5 id="33-other-nonfunctional-requirements">3.3  <a href="#other-nonfunctional-requirements">Other Nonfunctional Requirements </a></h5>
<blockquote>
<h6 id="331-http-requirements">3.3.1  <a href="#http-requirements">HTTP Requirements </a></h6>
<h6 id="332-logging-requirements">3.3.2  <a href="#logging-requirements">Logging Requirements </a></h6>
<h6 id="333-performance-requirements">3.3.3  <a href="#performance-requirements">Performance Requirements </a></h6>
<h6 id="334-safety-requirements">3.3.4  <a href="#safety-requirements">Safety Requirements </a></h6>
<h6 id="335-security-requirements">3.3.5  <a href="#security-requirements">Security Requirements </a></h6>
<h6 id="336-software-quality-attributes">3.3.6  <a href="#software-quality-attributes">Software Quality Attributes</a></h6>
<h6 id="337-business-rules">3.3.7  <a href="#business-rules">Business Rules </a></h6>
</blockquote>
<h5 id="34-compliance">3.4  <a href="#compliance">Compliance </a></h5>
<h5 id="35-design-and-implementation">3.5  <a href="#design-and-implementation">Design and Implementation </a></h5>
<blockquote>
<h6 id="351-installation">3.5.1  <a href="#installation">Installation </a></h6>
<h6 id="352-distribution">3.5.2  <a href="#distribution">Distribution </a></h6>
<h6 id="353-service-meshing">3.5.3  <a href="#service-meshing">Service Meshing </a></h6>
<h6 id="354-standard-technology">3.5.4  <a href="#standard-technology">Standard Technology </a></h6>
<h6 id="355-metrics">3.5.5  <a href="#metrics">Metrics </a></h6>
<h6 id="356-configurability">3.5.6  <a href="#configurability">Configurability </a></h6>
<h6 id="357-maintainability">3.5.7  <a href="#maintainability">Maintainability </a></h6>
<h6 id="358-reusability">3.5.8  <a href="#reusability">Reusability </a></h6>
<h6 id="359-runtime-stability">3.5.9  <a href="#runtime-stability">Runtime Stability </a></h6>
<h6 id="3510-high-availability-concepts">3.5.10 <a href="#high-availability-concepts">High Availability Concepts </a></h6>
</blockquote>
</blockquote>
<h4 id="4-system-features">4  <a href="#system-features">System Features </a></h4>
<blockquote>
<h5 id="41-policy-management">4.1  <a href="#policy-management">Policy Management </a></h5>
<blockquote>
<h6 id="411-description">4.1.1  <a href="#description">Description </a></h6>
<h6 id="412-functional-requirements">4.1.2  <a href="#functional-requirements">Functional Requirements </a></h6>
</blockquote>
<h5 id="42-policy-evaluation">4.2  <a href="#policy-evaluation">Policy Evaluation </a></h5>
<blockquote>
<h6 id="421-description">4.2.1  <a href="#description-policy-evaluation">Description </a></h6>
<h6 id="422-functional-requirements">4.2.2  <a href="#functional-requirements-policy-evaluation">Functional Requirements </a></h6>
</blockquote>
<h5 id="43-task-controller">4.3  <a href="#task-controller-system-features">Task Controller </a></h5>
<blockquote>
<h6 id="431-description">4.3.1  <a href="#description-task-controller">Description </a></h6>
<h6 id="432-functional-requirements">4.3.2  <a href="#functional-requirements-task-controller">Functional Requirements </a></h6>
</blockquote>
<h5 id="44-json-ld-signing-and-verification">4.4  <a href="#json-ld-signing-and-verification">JSON-LD Signing and verification </a></h5>
<blockquote>
<h6 id="441-description">4.4.1  <a href="#description-json-ld-signing-and-verification">Description </a></h6>
<h6 id="442-functional-requirements">4.4.2  <a href="#functional-requirements-json-ld-signing-and-verification">Functional Requirements </a></h6>
</blockquote>
<h5 id="45-trusted-caching">4.5  <a href="#trusted-caching">Trusted Caching </a></h5>
<blockquote>
<h6 id="451-description">4.5.1  <a href="#description-trusted-caching">Description </a></h6>
<h6 id="452-functional-requirements">4.5.2  <a href="#functional-requirements-trusted-caching">Functional Requirements </a></h6>
</blockquote>
<h5 id="46-eidas-compliant-signatures">4.6  <a href="#eidas-compliant-signatures">eIDAS Compliant Signatures </a></h5>
<blockquote>
<h6 id="461-description">4.6.1  <a href="#description-eidas-compliant-signatures">Description </a></h6>
<h6 id="462-functional-requirements">4.6.2  <a href="#functional-requirements-eidas-compliant-signatures">Functional Requirements </a></h6>
</blockquote>
</blockquote>
<h4 id="5-verification">5  <a href="#verification">Verification </a></h4>
<blockquote>
<h5 id="51-core-verification-requirements">5.1  <a href="#core-verification-requirements">Core Verification Requirements </a></h5>
<h5 id="52-acceptance-criteria">5.2  <a href="#acceptance-criteria">Acceptance Criteria </a></h5>
<blockquote>
<h6 id="521-policy-management-module">5.2.1  <a href="#policy-management-module-verification">Policy Management Module </a></h6>
<h6 id="522-policy-decision-engine">5.2.2  <a href="#policy-decision-engine-verification">Policy Decision Engine </a></h6>
<h6 id="523-task-controller">5.2.3  <a href="#task-controller-verification">Task Controller </a></h6>
<h6 id="524-json-ld-signatures-and-validations">5.2.4  <a href="#json-ld-signatures-and-validations-verification">JSON-LD signatures and validations</a></h6>
<h6 id="525-distributable-cache">5.2.5  <a href="#distributable-cache-verification">Distributable Cache </a></h6>
<h6 id="526-eidas">5.2.6  <a href="#eidas-verification">eIDAS </a></h6>
</blockquote>
<h5 id="53-support-for-kubernetes">5.3  <a href="#support-for-kubernetes">Support for Kubernetes </a></h5>
</blockquote>
<p><a href="#appendix-a-glossary">Appendix A: Glossary </a></p>
<p><a href="#appendix-b-architecture">Appendix B: Architecture </a></p>
<h1 id="list-of-figures">List of Figures</h1>
<blockquote>
<p>Figure 1: Architecture (semi-transparent boxes are out of scope) </p>
</blockquote>
<h1 id="list-of-tables">List of Tables</h1>
<blockquote>
<p>Table 1: References </p>
<p>Table 2: Apportioning of Requirements </p>
<p>Table 3: Technology Stack </p>
<p>Table 4: Functional Requirements Policy Management </p>
<p>Table 5: Functional Requirements Policy Evaluation </p>
<p>Table 6: Functional Requirements Task Controller </p>
<p>Table 7: Functional Requirements JSON-LD Signing and Verification </p>
<p>Table 8: Functional Requirements Trusted Caching </p>
<p>Table 9: Functional Requirements eIDAS Compliant Signatures</p>
</blockquote>
<h1 id="introduction">Introduction</h1>
<blockquote>
<p>To get general information regarding Gaia-X and the Gaia-X Federation Services please refer to [TAD] []{#1.1_Document_Purpose .anchor}and [PRD].</p>
</blockquote>
<h2 id="document-purpose">Document Purpose</h2>
<blockquote>
<p>The purpose of the document is to specify the requirements of the Identity Management and Trust Subcomponent "Trust Services API Extension 1" with the intention of a European wide public tender for implementing this software. Main audience for this document is attendees of the public tender, which are able to supply an open-source software solution for the area of Signing/Validation, Secure Policy Management and Policy Execution with the purpose to provide trusted services around Decision Evaluations and Verifications.</p>
</blockquote>
<h2 id="product-scope">Product Scope</h2>
<blockquote>
<p>The product scope covers the functionalities of the Trust Services API. The aim of the Trust Services API Extension 1 is to ensure a consistent level of trust between Gaia-X participants and components. The Trust Services API can be used by all components. The creation and validation of digital signatures plays a particularly important role here. The product scope includes signing and verifying of necessary data, enabling policy driven trust, ensuring trust-chains between participants and validating eIDAS compliant signatures.</p>
<p>The scope also includes necessary tools (e.g., Command Line Scripts) to operate and maintain the created software components in an enterprise environment with focus on high-availability, security and monitoring and logging based on common standards. Documentation for developer, operator and user MUST be written in markdown format which is publicly consumable over a publicly accessible source repository without access limitations.</p>
</blockquote>
<hr />
<blockquote>
<p><img alt="" src="../media/image2.png" />
If it's required to do code restructurings, modifying the current solution by adding new microservices etc. then this is explicitly allowed.</p>
<p>Please note, that it is explicitly required to deliver the software up and running. Responsibility for existing code cannot be shifted to previous development teams.</p>
</blockquote>
<hr />
<h2 id="definitions-acronyms-and-abbreviations">Definitions, Acronyms and Abbreviations</h2>
<blockquote>
<p>The Trust Architecture Overview Document [IDM.AO] MUST be considered and applied as the core technical concept that includes also the Terminology and Glossary.</p>
<p>All requirements from other documents are referenced by [IDM.\&lt;document-id&gt;.XXXXX] as defined in chapter 1 "Methodology" in the document [IDM.AO].</p>
</blockquote>
<h2 id="references">References</h2>
<table>
<thead>
<tr>
<th></th>
<th>Description</th>
<th>Status</th>
</tr>
</thead>
<tbody>
<tr>
<td><strong>Specflow (n.D.), BDD</strong></td>
<td><a href="https://specflow.org/bdd/">Specflow BDD</a></td>
<td>07-04-2023</td>
</tr>
<tr>
<td><strong>Cloud Events</strong></td>
<td><a href="https://cloudevents.io/">CloudEvents</a></td>
<td>07-04-2023</td>
</tr>
<tr>
<td><strong>D:EBSI</strong></td>
<td><a href="https://ec.europa.eu/digital-building-blocks/wikis/display/EBSIDOC/EBSI%2BDID%2BMethod">EBSI DID Method</a></td>
<td>07-04-2023</td>
</tr>
<tr>
<td><strong>IDM.AO</strong></td>
<td><a href="Link">Gaia-X WP1 (2021), Architecture Overview</a></td>
<td></td>
</tr>
<tr>
<td><strong>IDM.TRAIN</strong></td>
<td><a href="Link">Gaia-X Federation Services - Trust Management Infrastructure</a></td>
<td></td>
</tr>
<tr>
<td><strong>JSON-LD</strong></td>
<td><a href="https://w3c.github.io/json-ld-syntax/">JSON-LD 1.1</a></td>
<td>07-04-2023</td>
</tr>
<tr>
<td><strong>LD Proofs</strong></td>
<td><a href="https://w3c-ccg.github.io/ld-proofs/">Linked Data Proofs 1.0</a></td>
<td>07-04-2023</td>
</tr>
<tr>
<td><strong>PRD</strong></td>
<td><a href="Link">Gaia-X Policy Rules Document</a></td>
<td>08-14-2023</td>
</tr>
<tr>
<td><strong>Rego</strong></td>
<td><a href="https://www.openpolicyagent.org/docs/latest/policy-language/">Rego Policy Language</a></td>
<td>07-04-2023</td>
</tr>
<tr>
<td><strong>RFC 2119</strong></td>
<td><a href="https://tools.ietf.org/html/rfc2119">RFC 2119</a></td>
<td>07-04-2023</td>
</tr>
<tr>
<td><strong>RFC 5789</strong></td>
<td><a href="https://datatracker.ietf.org/doc/html/rfc5789">PATCH Method for HTTP</a></td>
<td>07-04-2023</td>
</tr>
<tr>
<td><strong>RFC 7231</strong></td>
<td><a href="https://tools.ietf.org/html/rfc7231">HTTP/1.1: Semantics and Content</a></td>
<td>07-04-2023</td>
</tr>
<tr>
<td><strong>RFC 7807</strong></td>
<td><a href="https://datatracker.ietf.org/doc/html/rfc7807">Problem Details for HTTP APIs</a></td>
<td>07-04-2023</td>
</tr>
<tr>
<td><strong>TAD</strong></td>
<td><a href="https://docs.gaia-x.eu/technical-committee/architecture-document/22.10/federation_service/">Gaia-X Architecture Document</a></td>
<td>08-14-2023</td>
</tr>
<tr>
<td><strong>TDR</strong></td>
<td>Gaia-X Federation Services Technical Development Requirements</td>
<td></td>
</tr>
<tr>
<td><strong>TSA</strong></td>
<td>Gaia-X, European Association for Data and Cloud, AISBL (2021): Gaia-X Trusted Services API Document</td>
<td></td>
</tr>
<tr>
<td><strong>TSA.GITLAB</strong></td>
<td><a href="https://gitlab.eclipse.org/groups/eclipse/xfsc/tsa/-/issues">Gitlab tickets for the GAIA-X Trust Services API</a></td>
<td></td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 1: References</p>
</blockquote>
<h2 id="document-overview">Document Overview</h2>
<blockquote>
<p>The document describes the product perspective, functions and constraints. It furthermore lists the functional and non-functional requirements and defines the system features in detail. The listed requirements are binding. Requirements as an expression of normative specifications are identified by a unique ID in square brackets (e.g. <strong>[IDM.ID.Number]</strong>) and the keywords MUST, MUST NOT, SHOULD, SHOULD NOT, MAY, corresponding to RFC 2119 [RFC 2119], are written in capital letters (see also [IDM.AO] - Methodology).</p>
</blockquote>
<h1 id="product-overview">Product Overview</h1>
<h2 id="product-perspective">Product Perspective</h2>
<blockquote>
<p>Please refer to [TDR] and [TSA]<em>.</em></p>
</blockquote>
<hr />
<blockquote>
<p><img alt="" src="../media/image2.png" /></p>
<p>The existing code base [1] MUST be reused and further improved. Other microservices MAY have different languages and architectures.</p>
</blockquote>
<h6 id="1-httpsgitlabeclipseorgeclipsexfsctsa">[1] <a href="https://gitlab.eclipse.org/eclipse/xfsc/tsa"><u>[https://gitlab.eclipse.org/eclipse/xfsc/tsa]</u></a></h6>
<hr />
<h2 id="product-functions">Product Functions</h2>
<blockquote>
<p>The functions of the Trust Services component are provided
 case-dependent either as runtime or library components. Runtime components MUST expose endpoints as REST services. In addition, policy configuration with GitOps should be used to enable the provisioning and sharing of policies. The component is part of the Gaia-X Trust and identity management toolstack and not centrally hosted. To properly maintain and update, appropriate security measures MUST be in place. This includes role concepts, data storage protection and access control. The overall functionality of the product MUST be auditable (GDPR compliant).
</p>
<p><img alt="" src="../media/image3.png" /></p>
<p>Figure 1: Architecture (semi-transparent boxes are out of scope)</p>
</blockquote>
<h2 id="product-constraints">Product Constraints</h2>
<blockquote>
<p>Please refer to [TSA] Section 2.3 and [TDR]<em>.</em></p>
</blockquote>
<h2 id="user-classes-and-characteristics">User Classes and Characteristics</h2>
<blockquote>
<p>Please refer to [TSA] 2.4 and [TDR]<em>.</em></p>
</blockquote>
<h2 id="operating-environment">Operating Environment</h2>
<blockquote>
<p>Please refer to [TSA] 2.5 and [TDR] for further binding requirements regarding the operating environment.</p>
</blockquote>
<h5 id="idmtsae100000-kubernetes-environment">[IDM.TSA.E1.00000] Kubernetes Environment</h5>
<blockquote>
<p>The product MUST be operable on standard Kubernetes based environments without any hardware restrictions. The reference environment for demonstration and development purposes MUST be on the provided SCS cluster (Sovereign Cloud Stack), which will be provided by the Client.
</p>
</blockquote>
<h2 id="user-documentation">User Documentation</h2>
<blockquote>
<p>Please refer to [TDR] for further requirements regarding documentation.</p>
</blockquote>
<h5 id="idmtsae100001-participant-administration-documentation">[IDM.TSA.E1.00001] Participant Administration Documentation</h5>
<blockquote>
<p>The documentation MUST contain:</p>
</blockquote>
<ul>
<li>
<p>Installation Manuals</p>
</li>
<li>
<p>Cryptographic Initialization (if applicable)</p>
</li>
<li>
<p>Description of Deployment/Compile Process</p>
</li>
<li>
<p>Description of the Automatic Tests / Verification</p>
</li>
<li>
<p>How to build the products from source code  </p>
</li>
</ul>
<h5 id="idmtsae100002-participant-documentation">[IDM.TSA.E1.00002] Participant Documentation</h5>
<blockquote>
<p>The documentation MUST contain:</p>
</blockquote>
<ul>
<li>
<p>Short Software Description (why and for what, when to use, how use, where to use)</p>
</li>
<li>
<p>Usage guide</p>
</li>
<li>
<p>GDPR design decisions</p>
</li>
<li>
<p>Security concept</p>
</li>
<li>
<p>Operations concept</p>
</li>
<li>
<p>FAQ</p>
</li>
<li>
<p>Keyword Directory  </p>
</li>
</ul>
<h2 id="assumptions-and-dependencies">Assumptions and Dependencies</h2>
<blockquote>
<p>An understanding of the overall Gaia-X architecture and philosophy is necessary. Please refer to [TAD] und [PDR].</p>
<p>Attendees of the public tender MUST assume responsibility of:</p>
</blockquote>
<ul>
<li>
<p>All tickets in GitLab ( [TSA.GITLAB] ) with label "Specification"</p>
</li>
<li>
<p>The existing code and improvements upon the existing code</p>
</li>
<li>
<p>Extending or contributing to the used frameworks in order to provision a way in which realization of the requirements can be achieved</p>
</li>
<li>
<p>Updating dependencies to the latest stable version</p>
</li>
</ul>
<h2 id="apportioning-of-requirements">Apportioning of Requirements</h2>
<table>
<thead>
<tr>
<th><strong>Feature</strong></th>
<th><strong>Priority</strong></th>
</tr>
</thead>
<tbody>
<tr>
<td>Policy Management</td>
<td>1</td>
</tr>
<tr>
<td>Policy Evaluation</td>
<td>1</td>
</tr>
<tr>
<td>Task Coordination</td>
<td>1</td>
</tr>
</tbody>
</table>
<table>
<thead>
<tr>
<th><strong>Feature</strong></th>
<th><strong>Priority</strong></th>
</tr>
</thead>
<tbody>
<tr>
<td>JSON-LD Verification</td>
<td>1</td>
</tr>
<tr>
<td>JSON-LD Signing</td>
<td>1</td>
</tr>
<tr>
<td>Trusted Caching</td>
<td>1</td>
</tr>
<tr>
<td>eIDAS compliant Signatures</td>
<td>2</td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 2: Apportioning of Requirements</p>
</blockquote>
<h1 id="requirements">Requirements</h1>
<blockquote>
<p>Further binding requirements can be found in [TDR].</p>
</blockquote>
<h2 id="external-interfaces">External Interfaces</h2>
<h3 id="user-interfaces">User Interfaces</h3>
<blockquote>
<p>Please refer to [TSA] 3.1.1.</p>
</blockquote>
<h3 id="hardware-interfaces">Hardware Interfaces</h3>
<blockquote>
<p>Please refer to [TSA] 3.1.2.</p>
</blockquote>
<h3 id="software-interfaces">Software Interfaces</h3>
<blockquote>
<p>Please refer to [TSA] 3.1.3.</p>
</blockquote>
<h3 id="communications-interfaces">Communications Interfaces</h3>
<blockquote>
<p>Please refer to [TSA] 3.1.4.</p>
</blockquote>
<h5 id="idmtsae100003-eventing">[IDM.TSA.E1.00003] Eventing</h5>
<blockquote>
<p>If it is required to use events within the software architecture, it is mandatory to use software abstraction according to cloud event specification [CloudEvents] for publishing and subscription. The minimal supported protocol binding MUST be HTTP Protocol Binding [2].</p>
</blockquote>
<h6 id="2-httpsgithubcomcloudeventsspecblobv102cloudeventsbindingshttp-protocol-bindingmd">[2] <a href="https://github.com/cloudevents/spec/blob/v1.0.2/cloudevents/bindings/http-protocol-binding.md"><u>[https://github.com/cloudevents/spec/blob/v1.0.2/cloudevents/bindings/http-protocol-binding.md]</u></a></h6>
<h5 id="idmtsae100004-eventing-infrastructure">[IDM.TSA.E1.00004] Eventing Infrastructure</h5>
<blockquote>
<p>The event broker for the eventing MUST abstract the storage and delivery infrastructure. In Kubernetes environments, the broker MUST be uniform across all Lots. (e.g., kNative)<br />
</p>
</blockquote>
<h2 id="functional">Functional</h2>
<h3 id="policy-management-module">Policy Management Module</h3>
<h5 id="idmtsae100005-policy-bundles">[IDM.TSA.E1.00005] Policy Bundles</h5>
<blockquote>
<p>Policy bundles MUST contain further information, e.g., data input JSON files. They MUST contain meta-data and references like resolvable DIDs to be verifiable and trustworthy. The bundle MUST be signed in a productive state or before the export. It MAY be chosen, how the signing and verification is standardized. For instance, the metadata can be signed for the included files of the bundle, or the bundle itself can be signed as a compressed package e.g., Zip packed in a CMS to exchange later on policy bundles.</p>
</blockquote>
<h5 id="idmtsae100006-policy-import-and-export">[IDM.TSA.E1.00006] Policy Import and Export</h5>
<blockquote>
<p>The policy administrator MUST be able to configure policy import endpoints where the system automatically downloads new policy bundles. The policy export endpoint itself MUST be configurable in that way, so that the policy administrator can decide which bundles from the productive repository can be exported. Each import and export MUST be signed with a key registered in the DID document and verifiable against the public keys from the DID document defined in the bundle. For this purpose, the DID resolver MUST be used. Import and export MUST be observable for the configured repositories.</p>
</blockquote>
<h5 id="idmtsae100007-policy-changes-notification">[IDM.TSA.E1.00007] Policy Changes Notification</h5>
<blockquote>
<p>The system MUST be able to notify other components when policy source code or data has changed. Notifications may be passed to message queue, smart contract or use other notification mechanisms which are suitable in the context of the technology stack. Notifications might be granular and explicitly contain information about what has changed.</p>
</blockquote>
<h5 id="idmtsae100008-webhooks-for-policy-changes">[IDM.TSA.E1.00008] Webhooks for policy changes</h5>
<blockquote>
<p>The product MUST allow other components to subscribe for policy changes via webhooks. Clients MUST be able to give a URL and the product MUST send the relevant payload once there are policy changes.</p>
</blockquote>
<h5 id="idmtsae100009-json-schema-validation-for-policy-output">[IDM.TSA.E1.00009] JSON Schema Validation for Policy Output</h5>
<blockquote>
<p>Optional policy configuration files may specify mandatory JSON schemas which must be part of the JSON output from a policy evaluation. The validation must check whether the schemas are present and must validate the JSON document with Strict validation. To execute the validation procedure, a new HTTP URL can be automatically generated.</p>
<p>Example:</p>
<p>Evaluation URL pattern: /{repo}/policies/{group}/{policyname}/{version}/evaluation Validation
URL pattern: /{repo}/policies/{group}/{policyname}/{version}/validation</p>
<p>If the validation fails, the policy service might LOCK the policy for execution and log an error/warning in the logs.</p>
</blockquote>
<h5 id="idmtsae100010-fine-granular-policy-management">[IDM.TSA.E1.00010] Fine granular policy management</h5>
<blockquote>
<p>The system SHOULD allow managing policies in separate GIT repositories. This will allow separate GIT Workflows for different system contexts. Synchronization mechanisms SHOULD be separate for different GIT repositories. A new URL path parameter SHOULD be introduced in order to achieve context separation upon policy evaluation.</p>
<p>Example:</p>
<p>Current evaluation URL:</p>
<blockquote>
<blockquote>
<p>../policy/<strong>{group}</strong>/<strong>{name}</strong>/<strong>{version}</strong>/evaluation Evaluation
URL with GIT Repository separation:</p>
<p>../policy/<strong>{repository}</strong>/<strong>{group}</strong>/<strong>{name}</strong>/<strong>{version}</strong>/evaluation</p>
</blockquote>
</blockquote>
</blockquote>
<h5 id="idmtsae100011-interface-for-export-configuration">[IDM.TSA.E1.00011] Interface for Export Configuration</h5>
<blockquote>
<p>The policy administration module MUST be able to define new export configurations for each policy. The system MUST have an automated export configuration update flow, that will always take the main branch of the configurations and publish them, making them available for execution.</p>
<p><em>Interface</em></p>
<p>GitOps</p>
<p><em>Input</em></p>
<p>Export configurations</p>
<p><em>Output</em></p>
<p>Updated Export Configurations are available for execution</p>
</blockquote>
<h5 id="idmtsae100012-policy-admin-api">[IDM.TSA.E1.00012] Policy Admin API</h5>
<blockquote>
<p>The policy service may provide an HTTP API to inspect the current policy service state. For example, get a list of all unlocked/locked policies, return a specific policy source code or some policy meta information like last update timestamp. This could be useful while debugging the service or for building a UI dashboard for administrators. For example, the sync from Git to Policy Database could fail unexpectedly or even complete without errors, but there could be a bug where policy source code in the database is different from policy source code in the Gilt repo. Debugging such issues would be extremely difficult without having the ability to look at the current Policy service state/data, because just looking at the external Git policy repo will not be helpful to discover some discrepancies.</p>
<p>The API could start with the following functionalities but could be further expanded as necessary.</p>
</blockquote>
<ul>
<li>
<p>Retrieve all/some policies from the Policy DB. Optionally specify which fields should be returned - e.g., source code, static data, meta fields, etc.</p>
</li>
<li>
<p>Retrieve policy lock/unlock state</p>
</li>
<li>
<p>Retrieve static data/configurations for a given policy</p>
</li>
</ul>
<h3 id="policy-decision-engine">Policy Decision Engine</h3>
<h5 id="idmtsae100013-call-of-external-urls">[IDM.TSA.E1.00013] Call of external URLs</h5>
<blockquote>
<p>The decision engine MUST have the capability to call HTTP URLs with free chosen query parameters, headers, and request bodies for any HTTP verb within the policy execution. This MUST be possible out of the defined policy to load external data dynamically into the execution context. It MAY be created also helper components e.g., built in functions, to support this feature outside of the policy policy execution context.</p>
<p><em>Constraints</em> Policy Language Policy Execution</p>
<p><em>Input</em></p>
<p>HTTP URL with Parameters, Header and Request Body.</p>
<p><em>Output</em></p>
<p>JSON HTTP Response.</p>
</blockquote>
<h5 id="idmtsae100014-storage-extension-functions">[IDM.TSA.E1.00014] Storage Extension Functions</h5>
<blockquote>
<p>The decision engine MUST have the capability to work with database storage, that a policy can persist and pick up data during execution. This MUST be achieved with REGO extension functions. The functions MUST have the ability to create, update and delete data from a predefined database table/collection during policy evaluations.</p>
<p><em>Constraints</em></p>
<p>Rego Policy Language [Rego]</p>
</blockquote>
<h5 id="idmtsae100015-storage-implementation">[IDM.TSA.E1.00015] Storage Implementation</h5>
<blockquote>
<p>The storage layer for policy storage MUST be implemented in a way that no specific database technology is strictly required for the purpose of policy execution. The implementation MUST support the following levels:</p>
</blockquote>
<ol>
<li>
<p>Policy Service uses internal storage for cloning the policy repositories. This level supports not just in time sync, but a very quick usage of simple, not often changed policies. Policy change requires container restart. This can be realized by a script during container startup (if configured)</p>
</li>
<li>
<p>The policy service uses an external storage to pick up the policies. E.g., from a postgres db, a mongodb or similar. The external storage provides events when a policy has changed, or a sync happens</p>
</li>
</ol>
<blockquote>
<p>Both levels MUST be configurable and adaptable by an internal interface e.g., IPolicyStorage to allow additional implementations in the future for internal and external storage implementations.</p>
</blockquote>
<h5 id="idmtsae100016-train-validation-verification">[IDM.TSA.E1.00016] TRAIN validation &amp; verification</h5>
<blockquote>
<p>The TRAIN validation service ([IDM.TRAIN.00017], [IDM.TRAIN] p. 12) needs to be included in the process of verifying a verifiable presentation. If a requestor is showing a verifiable presentation during a task which needs to be fulfilled the notarization service needs to validate the terms Of Use by calling the TRAIN validation module. This will verify if the shown verifiable presentation and its respective owner is on a trustlist.</p>
<p><em>Constraints</em></p>
<p>DID of the organization. Database system.</p>
<p><em>Interfaces</em></p>
<p>TRAIN validation module</p>
<p><em>Input</em></p>
<p>A verification with an incoming verifiable presentation</p>
<p><em>Output</em></p>
<p>Verification output of the TRAIN validation module</p>
</blockquote>
<h3 id="task-controller">Task Controller</h3>
<h5 id="idmtsae100017-cache-event-subscription">[IDM.TSA.E1.00017] Cache Event Subscription</h5>
<blockquote>
<p>If a data update event occurs from the distributable cache, the task controller MUST execute a policy which evaluates whether any further tasks must be created. If any task is configured, the tasks MUST be created for execution. The task has the same metadata as the event (key, namespace and scope)</p>
<p>For instance: A proof data object is inserted from the OCM into the cache. This object contains a DID from the issuer. The policy evaluates the schema of the data object and returns Task "IssuerProof". The task controller inserts this task to the tasklist by adding the http URL of the OCM proof manager with the DID of the issuer as parameter. Some seconds later, the proof from the issuer arrives and the policy returns null (nothing to do).</p>
<p><em>Constraints</em></p>
<p>Distributable Cache Event Policy Evaluation</p>
<p><em>Input</em></p>
<p>An Insert/Update Event</p>
<p><em>Output</em></p>
<p>A task result or null.</p>
</blockquote>
<h5 id="idmtsae100018-task-queue-and-storage-abstraction-layer">[IDM.TSA.E1.00018] Task Queue and Storage Abstraction Layer</h5>
<blockquote>
<p>An abstraction layer MUST be implemented for the Queue and the Storage interfaces in the task controller. The Abstraction layer MUST be agnostic of the underlying implementation.</p>
</blockquote>
<h3 id="json-ld-signatures-and-validations">JSON-LD signatures and validations</h3>
<h5 id="idmtsae100019-proof-chains-in-json-ld">[IDM.TSA.E1.00019] Proof Chains in JSON-LD</h5>
<blockquote>
<p>JSON-LD proof chains [LD.Proofs] SHOULD be supported to link multiple entities to the same data, when proof sequences are required. This can be useful for notary counter-signing a proof that had been created on a document. It MUST support signing and verifying the VCs.</p>
</blockquote>
<p>Example:</p>
<pre><code>            {

            &gt; \"@context\": \[
            &gt; \"https://[www.w3.org/2018/credentials/v1\"](http://www.w3.org/2018/credentials/v1),
            &gt; \"https://[www.w3.org/2018/credentials/examples/v1\"](http://www.w3.org/2018/credentials/examples/v1)
            &gt;
            &gt; \],
            &gt;
            &gt; \"title\": \"Hello World!\",
            &gt;
            &gt; \"proofChain\": \[{
            &gt;
            &gt; \"type\": \"Ed25519Signature2018\", \"proofPurpose\":
            &gt; \"assertionMethod\", \"created\": \"2019-08-23T20:21:34Z\",
            &gt;
            &gt; \"verificationMethod\": \"did:example:123456#key1\", \"domain\":
            &gt; \"example.org\",
            &gt;
            &gt; \"jws\": \"eyJ0eXAiOiJK\...gFWFOEjXk\"
            &gt;
            &gt; },
            &gt;
            &gt; {
            &gt;
            &gt; \"type\": \"RsaSignature2018\", \"proofPurpose\": \"assertionMethod\",
            &gt; \"created\": \"2017-09-23T20:21:34Z\",
            &gt;
            &gt; \"verificationMethod\": \"https://example.com/i/pat/keys/5\",
            &gt; \"domain\": \"example.org\",
            &gt;
            &gt; \"jws\": \"eyJ0eXAiOiJK\...gFWFOEjXk\"
            &gt;
            &gt; }\]
            &gt;
            &gt; }
</code></pre>
<h3 id="distributable-cache">Distributable Cache</h3>
<h5 id="idmtsae100020-content-access">[IDM.TSA.E1.00020] Content Access</h5>
<blockquote>
<p>The cached content MUST be accessible over a key (e.g., a DID), a namespace and an array of scopes, which results in an array of JSON documents. For instance, the access to the cache can be the following:</p>
<p>Key: DID:sov:2358585</p>
<p>Namespace: Login</p>
<p>Scopes: administration, read, visitor</p>
<p>Result: {"name":"userX","iss":did:sov:33333},</p>
<p>{"membership":"company","iss":did:sov:1111}</p>
<p>To optimize the access, it MAY be optimized by flatten the access pattern like: Key: DID:sov:2358585</p>
<p>Namespace: Login:administration</p>
<p>Independent from the format, the result for the accessor MUST be a flatten JSON structure. In the flattening step, it SHOULD namespace duplicated claims if they are semantically different (e.g., using JSON-LD context [JSON.LD]). If two JSON structures bring a duplicated claim which is semantically the same claim (say two JSON structures bring Name and Surname, but the values are different) then a policy shall decide whether to: take one of them or discard all of them.</p>
<p><em>Constraints</em></p>
<p>Supported data format of the cache technology Policy Decision Engine</p>
</blockquote>
<h3 id="eidas">eIDAS</h3>
<h5 id="idmtsae100021-eidas-compliant-signature-creation-validation">[IDM.TSA.E1.00021] eIDAS compliant Signature Creation / Validation</h5>
<blockquote>
<p>Signatures must be generated/verified in compliance with eIDAS so that legally secure trust can be achieved. This should include the eIDAS signature types basic, advanced, and qualified. The implementation variant must be selected individually in coordination with the used technology.</p>
</blockquote>
<h5 id="idmtsae100022-support-for-didebsi-encoding-for-natural-persons">[IDM.TSA.E1.00022] Support for DID:EBSI encoding for Natural Persons</h5>
<blockquote>
<p>Support public key encoding in DID document for Natural Persons according to the EBSI DID Method specification [DID:EBSI].</p>
<p><em>Constraints</em></p>
<p>EBSI DID Method [DID:EBSI].</p>
</blockquote>
<h3 id="general">General</h3>
<h5 id="idmtsae100023-architecture-restructuring">[IDM.TSA.E1.00023] Architecture Restructuring</h5>
<blockquote>
<p>The architecture of the existing TSA MUST be changed in this way, so that the software can be deployed feature by feature without the need to deploy for each feature every subcomponent like databases etc. In summary, all dependencies MUST be organized like this, that the deployment is more independent and operational cost friendly. The following changes MUST be provided:</p>
</blockquote>
<ul>
<li>
<p>The plain policy execution MUST be able to work without the mongoDB (e.g., by using git clone on container startup) Usage of MongoDB MUST be just optional by configuration</p>
</li>
<li>
<p>If the user wants to dynamically configure the policies, the policy execution MUST require mongoDB</p>
</li>
<li>
<p>The task controller feature MUST be shipped with a generic message queue interface to support usage of different queues (currently mongodb is the queue, other queues must not be provided)</p>
</li>
<li>
<p>The signing service MUST be more generic to support different signing engines</p>
</li>
<li>
<p>The policy execution MUST be aware of existing features and MUST reply during the policy execution the non-existence of the feature e.g., "Signing Service not available or this function requires the usage of MongoDB"</p>
</li>
</ul>
<blockquote>
<p>There may be other required changes during the architecture change, which MUST be highlighted to the technical lead and planned in the cost calculation during the analysis.</p>
<p>Overall goal of this requirement is to allow the users to reduce the costs of their operational environment. Means if a user decides to use just the policy execution, an operational setup for instance of mongoDB and redis MUST be not required to operate it 24/7.</p>
</blockquote>
<h2 id="other-nonfunctional-requirements">Other Nonfunctional Requirements</h2>
<h5 id="idmtsae100024-architecture-changes">[IDM.TSA.E1.00024] Architecture Changes</h5>
<blockquote>
<p>All Architecture Changes MUST be aligned with the Principal before implementation.  </p>
</blockquote>
<h3 id="http-requirements">HTTP Requirements</h3>
<h5 id="idmtsae100025-https">[IDM.TSA.E1.00025] HTTPS</h5>
<blockquote>
<p>All HTTP Endpoints MUST be protected by TLS 1.2 (all protocol version numbers SHOULD be superseded by upcoming standards) Each endpoint of the product MUST support TLS certificates which are configurable by the administrator of the system.  </p>
</blockquote>
<h5 id="idmtsae100026-http-protocol-definitions">[IDM.TSA.E1.00026] HTTP Protocol Definitions</h5>
<blockquote>
<p>All HTTP Endpoints MUST follow
<a href="https://tools.ietf.org/html/rfc7231">[RFC7231]</a> and
<a href="https://tools.ietf.org/html/rfc5789">[RFC5789],</a> but it MAY be chosen what of the protocols is necessary to realize the functionality. For problem reports the <a href="https://tools.ietf.org/html/rfc7807">[RFC7807]</a> MUST be used in combination with Standard HTTP Error Codes. </p>
</blockquote>
<h3 id="logging-requirements">Logging Requirements</h3>
<h5 id="idmtsae100027-data-minimization">[IDM.TSA.E1.00027] Data Minimization</h5>
<blockquote>
<p>The data minimization principle is expressed in Article 5(1)(c) of the GDPR and Article 4(1)(c) of Regulation (EU) 2018/1725, which provide that personal data must be \"adequate, relevant and limited to what is necessary in relation to the purposes for which they are processed\". The data shall be stored for a period of time in accordance with national requirements and, as a minimum, shall consist of the following elements:</p>
<blockquote>
<p>(a) node\'s identification</p>
<p>(b) message identification</p>
<p>(c) message data and time</p>
</blockquote>
<p>All logged data/information MUST be documented in the GDPR design decisions for a GDPR review.  </p>
</blockquote>
<h5 id="idmtsae100028-logging-frameworks">[IDM.TSA.E1.00028] Logging Frameworks</h5>
<blockquote>
<p>The product MUST support logging frameworks e.g., graylog, fluentD or logstash to support logging and analysis by enterprise infrastructures. The supported framework MAY be chosen for the first version, but it MUST support potentially the most common open-source logging solutions. The final solution MUST be aligned with the other subcomponents. It MUST be sketched in the operations concept how the support of multiple solutions is given in the future.</p>
</blockquote>
<h3 id="performance-requirements">Performance Requirements</h3>
<h5 id="idmtsae100029-updown-scale">[IDM.TSA.E1.00029] Up/Down Scale</h5>
<blockquote>
<p>All components MUST be able to scale up/down their functionality for undefined amount instances. This requires a parallel execution possibility which will be tested later on by performance tests which are defined by the test team.  </p>
</blockquote>
<h3 id="safety-requirements">Safety Requirements</h3>
<h5 id="idmtsae100030-major-releases">[IDM.TSA.E1.00030] Major Releases</h5>
<blockquote>
<p>All used software components MUST use the major releases with Long Term Support. If no LTS is available, all components MUST use the latest major releases with security hardening.  </p>
</blockquote>
<h3 id="security-requirements">Security Requirements</h3>
<h5 id="idmtsae100031-cve-patches">[IDM.TSA.E1.00031] CVE Patches</h5>
<blockquote>
<p>All software components MUST have applied CVE patches, which are available for major releases.  </p>
</blockquote>
<h3 id="software-quality-attributes">Software Quality Attributes</h3>
<h5 id="idmtsae100032-software-quality-requirements">[IDM.TSA.E1.00032] Software Quality Requirements</h5>
<blockquote>
<p>All software components MUST be compliant to the requirements within the quality assurance repository [3]. This includes testing on different layers (unit, component, integration), branch model that support stages, patch management, and code quality verification with adequate reporting. In addition, all requirements and quality attributes MUST demonstrated by automated behavior driven testing [BDD] methodology. </p>
</blockquote>
<h6 id="3-httpsgitlabcomgaia-xdata-infrastructure-federation-servicesquality-assurance-issues">[3] <a href="https://gitlab.com/gaia-x/data-infrastructure-federation-services/quality-assurance/-/issues"><u>[https://gitlab.com/gaia-x/data-infrastructure-federation-services/quality-assurance/-/issues]</u></a></h6>
<h3 id="business-rules">Business Rules</h3>
<h5 id="idmtsae100033-software-consistency">[IDM.TSA.E1.00033] Software Consistency</h5>
<blockquote>
<p>The used technologies MUST have consistency. Standard technologies e.g., Databases MUST be abstracted over JDBC, authentication over OIDC etc.  </p>
</blockquote>
<h5 id="idmtsae100034-cherry-picking">[IDM.TSA.E1.00034] Cherry Picking</h5>
<blockquote>
<p>All components and the entire software architecture MUST be checked for the necessity for deployment of each single feature, to allow an enterprise deployment customization.  </p>
</blockquote>
<h2 id="compliance">Compliance</h2>
<h5 id="idmtsae100035-gdpr-audit-logging">[IDM.TSA.E1.00035] GDPR Audit Logging</h5>
<blockquote>
<p>All GDPR relevant access to personal relevant data MUST be logged for a later audit.  </p>
</blockquote>
<h5 id="idmtsae100036-gdpr-data-processing">[IDM.TSA.E1.00036] GDPR Data Processing</h5>
<blockquote>
<p>Is it necessary to process person-relevant data, it MUST be earmarked to a clearly defined business process, which has to be described in the GDPR design decisions. All relevant data MUST be deleted after the processing, if applicable.  </p>
</blockquote>
<h2 id="design-and-implementation">Design and Implementation</h2>
<h3 id="installation">Installation</h3>
<h5 id="idmtsae100037-helmargo-cd-deployment">[IDM.TSA.E1.00037] Helm/Argo CD Deployment</h5>
<blockquote>
<p>All installations MUST be scripted/templated to ensure automated deployment. This MUST be ensured over HELM templates which MUST follow uniform rules across all lots. The charts MUST be integrable in a ARGO CD Pipeline defined in the gxfs-integration repository [4].  </p>
</blockquote>
<h6 id="4-httpsgitlabeclipseorgeclipsexfscintegration">[4] <a href="https://gitlab.eclipse.org/eclipse/xfsc/integration"><u>[https://gitlab.eclipse.org/eclipse/xfsc/integration]</u></a></h6>
<h3 id="distribution">Distribution</h3>
<h5 id="idmtsae100038-helm-repositories">[IDM.TSA.E1.00038] Helm Repositories</h5>
<blockquote>
<p>All component helm charts MUST be available under a helm repository hosted in the GitLab, with different channels for distribution [5].</p>
</blockquote>
<h6 id="5-httpsgitlabcomapiv4projects41175300packageshelmintegrationindexyaml">[5] <a href="https://gitlab.com/api/v4/projects/41175300/packages/helm/Integration/index.yaml"><u>[https://gitlab.com/api/v4/projects/41175300/packages/helm/Integration/index.yaml]</u></a></h6>
<h5 id="idmtsae100039-istio-resources">[IDM.TSA.E1.00039] Istio Resources</h5>
<blockquote>
<p>Additionally, the Charts MUST provide Istio Resource (e.g., Authorization Rules, Virtual Services etc. ) following the integration pattern specified in the gxfs-integration repo[6].  </p>
</blockquote>
<h6 id="6-httpsgitlabeclipseorgeclipsexfscintegration">[6] <a href="https://gitlab.eclipse.org/eclipse/xfsc/integration"><u>[https://gitlab.eclipse.org/eclipse/xfsc/integration]</u></a></h6>
<h3 id="service-meshing">Service Meshing</h3>
<h5 id="idmtsae100040-istio-support">[IDM.TSA.E1.00040] Istio Support</h5>
<blockquote>
<p>All HELM charts MUST be provided with Istio support aligned together with the project team. This consists of Authorization Rules, Virtual Service Definitions and other relevant Istio Definitions which are required for integration in a Istio Environment.  </p>
</blockquote>
<h3 id="standard-technology">Standard Technology</h3>
<h5 id="idmtsae100041-default-toolstack">[IDM.TSA.E1.00041] Default Toolstack</h5>
<blockquote>
<p>Each development MUST consider the following standard technologies, if nothing else is explicitly requested:</p>
</blockquote>
<table>
<thead>
<tr>
<th><strong>Area</strong></th>
<th><strong>Technology</strong></th>
</tr>
</thead>
<tbody>
<tr>
<td>Service Meshing</td>
<td>Istio</td>
</tr>
<tr>
<td>Databases</td>
<td>Redis, Mongo, Postgres</td>
</tr>
<tr>
<td>Messaging</td>
<td>CloudEvents</td>
</tr>
<tr>
<td>Continuous Integration</td>
<td>Argo CD, Gitlab</td>
</tr>
<tr>
<td>Installation Templates</td>
<td>HELM</td>
</tr>
<tr>
<td>Container</td>
<td>Docker Images (ARM64/AMD64)</td>
</tr>
<tr>
<td>Secret Storage</td>
<td>Hashicorp Vault, k8s Secret</td>
</tr>
<tr>
<td>UI Technology</td>
<td>React [7]</td>
</tr>
<tr>
<td>Ingress Controller</td>
<td>Nginx/Istio</td>
</tr>
<tr>
<td>API Testing</td>
<td>Postman (manual)</td>
</tr>
<tr>
<td>API Design</td>
<td>OpenAPI</td>
</tr>
<tr>
<td>Kubernetes</td>
<td>v1.26+</td>
</tr>
<tr>
<td>&gt; Table 3: Technology Stack</td>
<td></td>
</tr>
</tbody>
</table>
<h6 id="7-httpsreact-bootstrapgithubio">[7] <a href="https://react-bootstrap.github.io/"><u>[https://react-bootstrap.github.io/]</u></a></h6>
<hr />
<blockquote>
<p><img alt="" src="../media/image2.png" /> </p>
<p>The technology stack is mandatory to avoid integration impact. </p>
</blockquote>
<hr />
<h3 id="metrics">Metrics</h3>
<h5 id="idmtsae100042-opentelemtry-support">[IDM.TSA.E1.00042] Opentelemtry Support</h5>
<blockquote>
<p>All helm charts/services MUST provide metrics endpoints in opentelemetry [8]format.</p>
</blockquote>
<h6 id="8-httpsopentelemetryiodocs">[8] <a href="https://opentelemetry.io/docs/"><u>[https://opentelemetry.io/docs/]</u></a></h6>
<h3 id="configurability">Configurability</h3>
<h5 id="idmtsae100043-configuration">[IDM.TSA.E1.00043] Configuration</h5>
<blockquote>
<p>All components MUST support one of the major configuration formats (yaml, json, ini, environment variables) wherever configuration is required. If environment variables are overwriting an actively set configuration, a warning SHOULD be logged.  </p>
</blockquote>
<h5 id="idmtsae100044-configuration-profiles">[IDM.TSA.E1.00044] Configuration Profiles</h5>
<blockquote>
<p>Environment specific parameters MUST be configurable over the helm templates by using profiles. Each component MUST be delivered minimum for profile:</p>
</blockquote>
<ul>
<li>
<p>DEV, a local environment for round trip development and testing</p>
</li>
<li>
<p>Acceptance, a restricted resource environment (with minimal system requirements) which can be deployed in cluster (remote or locally)</p>
</li>
<li>
<p>Prod, a scalable environment with fault tolerance, HA settings and security hardening.</p>
</li>
</ul>
<blockquote></blockquote>
<h5 id="idmtsae100045-secret-references-in-helm-charts">[IDM.TSA.E1.00045] Secret References in Helm Charts</h5>
<blockquote>
<p>The configuration secrets within Helm Charts MUST use secretRefs to support external Secretmanagement. Clear text secrets within the Helm Charts are not allowed.  </p>
</blockquote>
<h3 id="maintainability">Maintainability</h3>
<h5 id="idmtsae100046-micro-service-architecture">[IDM.TSA.E1.00046] Micro Service Architecture</h5>
<blockquote>
<p>For a better scale out, maintainability and decentralization, the product architecture MUST have a micro service architecture. Each microservice MUST NOT be limited on the lines of code or number of days to implement it. The service "size" SHOULD be oriented on the fine granular business capabilities. (e.g., Order, ListMenu, Payment).
</p>
</blockquote>
<h5 id="idmtsae100047-domain-driven-design">[IDM.TSA.E1.00047] Domain Driven Design</h5>
<blockquote>
<p>To support the micro service architecture within the maintainability, it MUST be declared a domain model before realization. The software description MUST explain which domain model was chosen, which services contain it and how it scales. This MUST be documented in the public code repository to support future enhancements for new developers.  </p>
</blockquote>
<h3 id="reusability">Reusability</h3>
<h5 id="idmtsae100048-enterprise-environments">[IDM.TSA.E1.00048] Enterprise Environments</h5>
<blockquote>
<p>All components MUST be reusable in different enterprise environments by customization and whitelabeling. Means all components MUST be able to customize and white label the components by configuration settings (e.g., UIs, text labels, endpoints etc.)  </p>
</blockquote>
<h3 id="runtime-stability">Runtime Stability</h3>
<h5 id="idmtsae100049-readiness-check-ups">[IDM.TSA.E1.00049] Readiness Check Ups</h5>
<blockquote>
<p>All components MUST reflect after bootstrap and during runtime the correctness of the service functionality by reflecting it over health endpoints. The health endpoint MUST return failure (red), if any internal behavior failure or misconfiguration occurs (not just the software running state). This means for instance to check continuously during the runtime:</p>
</blockquote>
<ul>
<li>
<p>A unreachable configured Services results in failed state</p>
</li>
<li>
<p>Configured Service Endpoints needs to be checked for readiness during runtime, if not reachable, it results in failure state</p>
</li>
<li>
<p>Check depending components (Database, Microservice etc.) behind it, if not reachable, it results in failed state  </p>
</li>
</ul>
<h3 id="high-availability-concepts">High Availability Concepts</h3>
<h5 id="idmtsae100050-redundant-deployment">[IDM.TSA.E1.00050] Redundant Deployment</h5>
<blockquote>
<p>Each deployment MUST be configured for a minimum fault tolerance of 2 instances.  </p>
</blockquote>
<h1 id="system-features">System Features</h1>
<h2 id="policy-management">Policy Management</h2>
<h3 id="description-policy-management">Description - Policy Management</h3>
<blockquote>
<p>The policy management provides functionalities around the signing, validation, import, export, and merge of policies from internal and external policy repos. This is necessary to ensure that only trusted policies are imported from trusted resources. The feature must help and support the policy administrator in decisions to trust a policy repository from outside, trust imported policies, sign policies for export, export specific policies and merge changes into the productive repository. This feature can be automated by a continuous integration system (e.g., Jenkins), but it SHOULD include configurable manual reviewing steps to ensure that the signing of policies MUST be done by an authorized person.</p>
</blockquote>
<h3 id="functional-requirements-policy-management">Functional Requirements - Policy Management</h3>
<table>
<thead>
<tr>
<th>Endpoints</th>
</tr>
</thead>
<tbody>
<tr>
<td>Webhooks for policy changes</td>
</tr>
<tr>
<td>JSON Schema Validation for Policy Output</td>
</tr>
<tr>
<td>Fine granular policy management</td>
</tr>
<tr>
<td>Policy Admin API</td>
</tr>
</tbody>
</table>
<table>
<thead>
<tr>
<th>Functions</th>
</tr>
</thead>
<tbody>
<tr>
<td>Policy Bundles</td>
</tr>
<tr>
<td>Policy Import and Export</td>
</tr>
<tr>
<td>Policy Changes Notification</td>
</tr>
<tr>
<td>Interface for Export Configuration</td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 4: Functional Requirements Policy Management</p>
</blockquote>
<h2 id="policy-evaluation">Policy Evaluation</h2>
<h3 id="description-policy-evaluation">Description - Policy Evaluation</h3>
<blockquote>
<p>The policy evaluation provides functionality around the execution of policies. This includes the provisioning of versioned HTTP routes to execute the policy, synchronous and asynchronous policy evaluation, usage of external HTTP resources within the execution and a policy decision engine to create JSON response for a given JSON request and helper functionality around it. For instance, the caching of results or the inclusion of static JSON documents into the policy decisions, to evaluate more complex policies. All policies and static documents for the execution must be loaded from the encrypted hard disk into memory to guarantee the maximum execution speed. Temporary JSON documents can be stored into an open-source database for caching and SHOULD be deleted when no longer required. Any process or user behaves as an actor if the policy route was called.</p>
</blockquote>
<h3 id="functional-requirements-policy-evaluation">Functional Requirements - Policy Evaluation</h3>
<table>
<thead>
<tr>
<th>Functions</th>
</tr>
</thead>
<tbody>
<tr>
<td>Call of external URLs</td>
</tr>
<tr>
<td>Storage Extension Functions</td>
</tr>
<tr>
<td>Storage Implementation</td>
</tr>
<tr>
<td>TRAIN validation &amp; verification</td>
</tr>
<tr>
<td>CLI tools (command-line) for common operations</td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 5: Functional Requirements Policy Evaluation</p>
</blockquote>
<h2 id="task-controller-system-features">Task Controller - System Features</h2>
<h3 id="description-task-controller">Description - Task Controller</h3>
<blockquote>
<p>The task controller feature provides an API which is able to handle asynchronous task lists. Each task represents one single action which executes an HTTP URL. Each task has a unique id and stores its result in the distributable cache for a later processing. Task lists can be preconfigured in the repository by a name, to create a new task subset more easily from a policy or any other component (e.g., a 1 to many task mapping).</p>
<p>The task execution is asynchronous, and the result can be queried over the task(list) id, to query the state of the processing.</p>
</blockquote>
<h3 id="functional-requirements-task-controller">Functional Requirements - Task Controller</h3>
<table>
<thead>
<tr>
<th>Functions</th>
</tr>
</thead>
<tbody>
<tr>
<td>Cache Event Subscription</td>
</tr>
<tr>
<td>Task Queue and Storage Abstraction Layer</td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 6: Functional Requirements Task Controller</p>
</blockquote>
<h2 id="json-ld-signing-and-verification">JSON-LD Signing and verification</h2>
<h3 id="description-json-ld-signing-and-verification">Description - JSON-LD Signing and verification</h3>
<blockquote>
<p>The feature provides verification and signature functionality of LD-Proofs embedded in JSON-LD files. The functionality is an internal HTTP API, but the core crypto functionality has to be provided as a separate library and SHOULD run within a secure environment.</p>
</blockquote>
<h3 id="functional-requirements-json-ld-signing-and-verification">Functional Requirements - JSON-LD Signing and verification</h3>
<table>
<thead>
<tr>
<th>Functions</th>
</tr>
</thead>
<tbody>
<tr>
<td>Proof Chains in JSON-LD</td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 7: Functional Requirements JSON-LD Signing and Verification</p>
</blockquote>
<h2 id="trusted-caching">Trusted Caching</h2>
<h3 id="description-trusted-caching">Description - Trusted Caching</h3>
<blockquote>
<p>The trusted caching provides the functionality to store securely in memory data for identities and related information for trust evaluation.</p>
</blockquote>
<h3 id="functional-requirements-trusted-caching">Functional Requirements - Trusted Caching</h3>
<table>
<thead>
<tr>
<th>Functions</th>
</tr>
</thead>
<tbody>
<tr>
<td>Content Access</td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 8: Functional Requirements Trusted Caching</p>
</blockquote>
<h2 id="eidas-compliant-signatures">eIDAS Compliant Signatures</h2>
<h3 id="description-eidas-compliant-signatures">Description - eIDAS Compliant Signatures</h3>
<blockquote>
<p>To provide eIDAS compliant signatures the feature should be able to generate and validate eIDAS compliant signatures. In consideration of the different eIDAS types, legal signatures should be considered and a bridge functionality to sign the data should be implemented. A secure environment MUST be provided to store and execute the necessary functions (signature, validation) and SHOULD require at least two factor authentication.</p>
</blockquote>
<h3 id="functional-requirements-eidas-compliant-signatures">Functional Requirements - eIDAS Compliant Signatures</h3>
<table>
<thead>
<tr>
<th>Functions</th>
</tr>
</thead>
<tbody>
<tr>
<td>eIDAS compliant Signature Creation / Validation</td>
</tr>
<tr>
<td>Support for DID:EBSI encoding for Natural Persons</td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 9: Functional Requirements eIDAS Compliant Signatures</p>
</blockquote>
<h1 id="verification">Verification</h1>
<h2 id="core-verification-requirements">Core Verification Requirements</h2>
<blockquote>
<p>All listed verification items/criterias, must be fulfilled by a demonstration of the implementation within the provided Kubernetes environment.</p>
</blockquote>
<h5 id="idmtsae100051-kubernetes-deployment">[IDM.TSA.E1.00051] Kubernetes Deployment</h5>
<blockquote>
<p>If the verification is related to software components, it must be deployed in a Kubernetes test cluster and the components must be deployable in a Kubernetes cluster with automated package manager deployment (e.g., Helm).
</p>
</blockquote>
<hr />
<blockquote>
<p><img alt="" src="../media/image2.png" /></p>
<p>Docker Compose and other local systems can be used for local development and testing, but it's NOT allowed for a final acceptance demonstration.</p>
</blockquote>
<hr />
<h5 id="idmtsae100052-behavior-driven-design">[IDM.TSA.E1.00052] Behavior Driven Design</h5>
<blockquote>
<p>Verification of fulfillment of the requirements and characteristics MUST be done using automated tests which are part of the deliverables. They SHOULD be done by patterns of the Behavior Driven Development [BDD] using the "Gherkin Syntax".  </p>
</blockquote>
<h5 id="idmtsae100053-test-environment">[IDM.TSA.E1.00053] Test Environment</h5>
<blockquote>
<p>All functionalities MUST be demonstrated in a test environment within a sandbox, with the following infrastructure components:</p>
<p>Load Balancer, e.g., HAProxy API Gateway, e.g., Kong</p>
<p>Service Mesh, e.g., Linkerd/Istio DNS</p>
<p>Multiple Servers Firewalls</p>
<p>All tests MUST be passed in this test environment.  </p>
</blockquote>
<h5 id="idmtsae100054-load-tests">[IDM.TSA.E1.00054] Load Tests</h5>
<blockquote>
<p>Scalability and Performance around the high workload scenarios MUST be demonstrated, by using any kind of Load Test Framework for HTTP APIs.
</p>
</blockquote>
<h5 id="idmtsae100055-automated-integration-tests">[IDM.TSA.E1.00055] Automated Integration Tests</h5>
<blockquote>
<p>Automation Integration tests must be created, and they must be runnable by a CI job.  </p>
</blockquote>
<h2 id="acceptance-criteria">Acceptance Criteria</h2>
<h3 id="policy-management-module-verification">Policy Management Module - Verification</h3>
<h5 id="idmtsae100056-policy-bundles">[IDM.TSA.E1.00056] Policy Bundles</h5>
<blockquote>
<p>Policy Bundles are signed when they become in a productive state or before export. The metadata can be signed for the included files of the bundle, or the bundle itself can be signed as a compressed package. </p>
</blockquote>
<h5 id="idmtsae100057-policy-import-and-export">[IDM.TSA.E1.00057] Policy Import and Export</h5>
<blockquote>
<p>The export of a policy bundle MUST be signed with a keypair which is evaluable against the public keys registered in the DID document. Import and Exports are observable. </p>
</blockquote>
<h5 id="idmtsae100058-policy-changes-notification">[IDM.TSA.E1.00058] Policy Changes Notification</h5>
<blockquote>
<p>A notification is triggered upon every change in a policy source code or static data file. </p>
</blockquote>
<h5 id="idmtsae100059-webhooks-for-policy-changes">[IDM.TSA.E1.00059] Webhooks for policy changes</h5>
<blockquote>
<p>There is an available endpoint for client webhook subscription which takes a URL. Data payload is sent to all subscribers with relevant policy changes using the webhook URLs. </p>
</blockquote>
<h5 id="idmtsae100060-json-schema-validation-for-policy-output">[IDM.TSA.E1.00060] JSON Schema Validation for Policy Output</h5>
<blockquote>
<p>A simple JSON schema is validated on the validation endpoint. An appropriate HTTP status code is returned. </p>
</blockquote>
<h5 id="idmtsae100061-fine-granular-policy-management">[IDM.TSA.E1.00061] Fine granular policy management</h5>
<blockquote>
<p>The system allows policy management through separate GIT repositories. Separate synchronization mechanisms are in place for each GIT repository. </p>
</blockquote>
<h5 id="idmtsae100062-interface-for-export-configuration">[IDM.TSA.E1.00062] Interface for Export Configuration</h5>
<blockquote>
<p>Export configurations are able to be defined in the policy management module. There is a synchronization flow in place for export configurations to make them available for execution. </p>
</blockquote>
<h5 id="idmtsae100063-policy-admin-api">[IDM.TSA.E1.00063] Policy Admin API</h5>
<p>An administration API for policies is available. </p>
<h3 id="policy-decision-engine-verification">Policy Decision Engine - Verification</h3>
<h5 id="idmtsae100064-call-of-external-urls">[IDM.TSA.E1.00064] Call of external URLs</h5>
<blockquote>
<p>The decision engine is capable of making HTTP requests with query parameters, headers and request body for any HTTP method within the policy execution runtime. </p>
</blockquote>
<h5 id="idmtsae100065-storage-extension-functions">[IDM.TSA.E1.00065] Storage Extension Functions</h5>
<blockquote>
<p>REGO extension functions are available for creating, updating and deleting data from a predefined database table/collection during policy evaluation. </p>
</blockquote>
<h5 id="idmtsae100066-storage-implementation">[IDM.TSA.E1.00066] Storage Implementation</h5>
<blockquote>
<p>A storage layer can be replaced during the configuration in the deployment without any need to do code modifications. If internal storage is configured, the policy must be executable without any database deployment.  </p>
</blockquote>
<h5 id="idmtsae100067-train-validation-verification">[IDM.TSA.E1.00067] TRAIN validation &amp; verification</h5>
<blockquote>
<p>The service is able to use the components provided by the TRAIN lot to cross check the DID trust during the verification of credentials. </p>
</blockquote>
<h5 id="idmtsae100068-cli-tools-command-line-for-common-operations">[IDM.TSA.E1.00068] CLI tools (command-line) for common operations</h5>
<blockquote>
<p>CLI tools for the common operations, performed by the TSA HTTP API are created. </p>
</blockquote>
<h3 id="task-controller-verification">Task Controller - Verification</h3>
<h5 id="idmtsae100069-cache-event-subscription">[IDM.TSA.E1.00069] Cache Event Subscription</h5>
<blockquote>
<p>After an update event in the distributable cache, a task must be created as pre-configured (or dynamically by policy). </p>
</blockquote>
<h5 id="idmtsae100070-task-queue-and-storage-abstraction-layer">[IDM.TSA.E1.00070] Task Queue and Storage Abstraction Layer</h5>
<blockquote>
<p>An abstraction layer is implemented for the Queue and Storage interfaces in the Task Controller. </p>
</blockquote>
<h3 id="json-ld-signatures-and-validations-verification">JSON-LD signatures and validations - Verification</h3>
<h5 id="idmtsae100071-proof-chains-in-json-ld">[IDM.TSA.E1.00071] Proof Chains in JSON-LD</h5>
<blockquote>
<p>JSON-LD proof chains are supported to link multiple entities to the same data, when proof sequences are required.  </p>
</blockquote>
<h3 id="distributable-cache-verification">Distributable Cache - Verification</h3>
<h5 id="idmtsae100072-content-access">[IDM.TSA.E1.00072] Content Access</h5>
<blockquote>
<p>When accessing a content with given DID, namespace and scope, the result is a flat JSON file. Duplicate entries are handled during the flattening of multiple documents. </p>
</blockquote>
<h3 id="eidas-verification">eIDAS - Verification</h3>
<h5 id="idmtsae100073-eidas-compliant-signature-creation-validation">[IDM.TSA.E1.00073] eIDAS compliant Signature Creation / Validation</h5>
<blockquote>
<p>Signatures are generated/verified in compliance with eIDAS. Basic, advanced and qualified signature types are supported. </p>
</blockquote>
<h5 id="idmtsae100074-support-for-didebsi-encoding-for-natural-persons">[IDM.TSA.E1.00074] Support for DID:EBSI encoding for Natural Persons</h5>
<blockquote>
<p>Public key encoding in DID document for Natural Persons according to the EBSI DID Method is supported.  </p>
</blockquote>
<h2 id="support-for-kubernetes">Support for Kubernetes</h2>
<h5 id="idmtsae100075-eventing">[IDM.TSA.E1.00075] Eventing</h5>
<blockquote>
<p>All eventings must be demonstrated on basis of cloud events specifications together with the kNative [9] broker in a Kubernetes environment.   </p>
</blockquote>
<h6 id="9-httpsknativedevdocseventing">[9] <a href="https://knative.dev/docs/eventing/"><u>[https://knative.dev/docs/eventing/]</u></a></h6>
<h5 id="idmtsae100076-config-map-support">[IDM.TSA.E1.00076] Config Map Support</h5>
<blockquote>
<p>Each service must be demonstrated up and running in Kubernetes, configured by config maps.  </p>
</blockquote>
<h5 id="idmtsae100077-helm-installation">[IDM.TSA.E1.00077] Helm Installation</h5>
<blockquote>
<p>The service installation MUST be demonstrated during HELM install.   </p>
</blockquote>
<h5 id="idmtsae100078-argocd-integration">[IDM.TSA.E1.00078] ArgoCD Integration</h5>
<blockquote>
<p>The helm chart MUST be able to install inside of ArgoCD. This includes the usage of the postgres hooks [10] and the providing of usable values.yaml(s) for all developed services. </p>
</blockquote>
<h6 id="10-httpsgitlabcomgaia-xdata-infrastructure-federation-servicesgxfs-integration-treemainhelmchartspostgresql-hook">[10] <a href="https://gitlab.com/gaia-x/data-infrastructure-federation-services/gxfs-integration/-/tree/main/helm/charts/postgresql-hook"><u>[https://gitlab.com/gaia-x/data-infrastructure-federation-services/gxfs-integration/-/tree/main/helm/charts/postgresql-hook]</u></a></h6>
<blockquote></blockquote>
<h5 id="idmtsae100079-scs-environment">[IDM.TSA.E1.00079] SCS Environment</h5>
<blockquote>
<p>All HELM installations MUST run on SCS (Sovereign Cloud Stack). The final acceptance demonstration cannot be realized on azure, google cloud etc.   </p>
</blockquote>
<h1 id="appendix-a-glossary">Appendix A: Glossary</h1>
<blockquote>
<p>For the glossary refer to IDM.AO Glossary/Terminology [IDM.AO]</p>
</blockquote>
<h1 id="appendix-b-architecture">Appendix B: Architecture</h1>
<p><img alt="" src="../media/image4.png" /></p>
              
            </div>
          </div><footer>
    <div class="rst-footer-buttons" role="navigation" aria-label="Footer Navigation">
        <a href="../../pcme1/pcme1/" class="btn btn-neutral float-left" title="Personal Credential Manager Extension 1"><span class="icon icon-circle-arrow-left"></span> Previous</a>
    </div>

  <hr/>

  <div role="contentinfo">
    <!-- Copyright etc -->
  </div>

  Built with <a href="https://www.mkdocs.org/">MkDocs</a> using a <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>.
</footer>
          
        </div>
      </div>

    </section>

  </div>

  <div class="rst-versions" role="note" aria-label="Versions">
  <span class="rst-current-version" data-toggle="rst-current-version">
    
    
      <span><a href="../../pcme1/pcme1/" style="color: #fcfcfc">&laquo; Previous</a></span>
    
    
  </span>
</div>
    <script src="../../js/jquery-3.6.0.min.js"></script>
    <script>var base_url = "../..";</script>
    <script src="../../js/theme_extra.js"></script>
    <script src="../../js/theme.js"></script>
      <script src="../../search/main.js"></script>
    <script>
        jQuery(function () {
            SphinxRtdTheme.Navigation.enable(true);
        });
    </script>

</body>
</html>
